
/**
 * /!\ This file is automatically generated by QLALR from CooLexerIO.g.
 * /!\ Don't edit it!
 */

#include "CooLexerIO.hpp"

#include <QRegularExpression>

#include <ShareablePoints/ShareableExtraInfos.hpp>
#include <ShareablePoints/ShareableFrame.hpp>
#include <ShareablePoints/ShareableParams.hpp>
#include <ShareablePoints/ShareablePoint.hpp>
#include <ShareablePoints/ShareablePosition.hpp>

namespace
{
inline QString toTrimmedQString(const QStringRef &str)
{
	return str.trimmed().toString();
}
} // namespace

void CooLexerIO::consumeRule(int rule)
{
	switch(rule)
	{

	case 6:
		addStyleSym(Styles::Normal, 1);
		break;

	case 7:
		addStyleSym(Styles::Normal, 2);
		break;
 case 8:  case 9:  case 10: 
	case 11:
		addStyle(1, Styles::Comment);
		addStyle(sym(1).size() - 1, Styles::Referential);
		if (!_lexerMode)
			_curList.getParams().extraInfos["coordinateSystem"] = toByteArray(toTrimmedQString(sym(1).mid(1)), utf8()).constData();
		break;

	case 12:
		addStyleSym(Styles::PointName, 1);
		_columnsHeader = _currentLine.trimmed().toString();
		break;
 case 13:  case 14:  case 15: 
	case 16:
		addStyleSym(Styles::PointCoordinate, 1);
		break;

	case 17:
		addStyleSym(Styles::PointCoordinate, 1);
		_curList.getParams().coordsys = ShareableParams::ECoordSys::k2DPlusH;
		break;
 case 18:  case 19: 
	case 20:
		addStyleSym(Styles::PointSigmaKeyword, 1);
		break;
 case 21:  case 22:  case 23: 
	case 24:
		addStyleSym(Styles::PointDisplacement, 1);
		break;
 case 25: 
	case 26:
		addStyleSym(Styles::PointInfo, 1);
		break;

	case 27:
		addStyleSym(Styles::PointType, 1);
		break;
 case 28:  case 29: 
	case 30:
		addStyleSym(Styles::Normal, 1);
		break;
 case 31:  case 32:  case 33:  case 34:  case 35: 
	case 36:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		break;
 case 37: 
	case 38:
		_columnsHeader += '\n' + _currentLine.trimmed().toString();
		break;

	case 39:
		addStyleSym(Styles::Normal, 1);
		_contexts.push_back(CooLexerIO::HTOLMODE);
		break;

	case 40:
		addStyleSym(Styles::PointName, 1);
		_columnsHeader = _currentLine.trimmed().toString();
		break;

	case 41:
		addStyleSym(Styles::FrameID, 1);
		break;
 case 42:  case 43:  case 44:  case 45:  case 46: 
	case 47:
		addStyleSym(Styles::PointCoordinate, 1);
		break;
 case 48:  case 49:  case 50:  case 51:  case 52: 
	case 53:
		addStyleSym(Styles::PointDisplacement, 1);
		break;
 case 54: 
	case 55:
		addStyleSym(Styles::PointType, 1);
		break;

	case 56:
		addStyleSym(Styles::Frame, 1);
		gotFrameName(sym(1));
		break;

	case 57:
		addStyleSym(Styles::FrameID, 1);
		break;
 case 58:  case 59:  case 60:  case 61:  case 62: 
	case 63:
		addStyleSym(Styles::FrameTranslation, 1);
		break;
 case 64:  case 65:  case 66:  case 67:  case 68: 
	case 69:
		addStyleSym(Styles::FrameRotation, 1);
		break;
 case 70: 
	case 71:
		addStyleSym(Styles::PointType, 1);
		break;
 case 72: 
	case 73:
		addStyleSym(Styles::PointName, 1);
		if (!_lexerMode)
		{
			_curPoint = &_curFrame->addPoint();
			_curPoint->name = toByteArray(toTrimmedQString(sym(1)), utf8()).constData();
		}
		if (!_contexts.empty() && _contexts.back() == CooLexerIO::OUT1MODE)
			_inlineContexts.insert(CooLexerIO::OUT1MODE);
		gotPointName(sym(1));
		break;

	case 74:
		addStyleSym(Styles::PointCoordinate, 1);
		if (!_lexerMode)
			_curPoint->position.x = sym(1).toDouble();
		gotPointCoordinate(sym(1));
		break;

	case 75:
		addStyleSym(Styles::PointCoordinate, 1);
		if (!_lexerMode)
			_curPoint->position.y = sym(1).toDouble();
		gotPointCoordinate(sym(1));
		break;

	case 76:
		addStyleSym(Styles::PointCoordinate, 1);
		if (!_lexerMode)
			_curPoint->position.z = sym(1).toDouble();
		gotPointCoordinate(sym(1));
		break;

	case 77:
		addStyleSym(Styles::PointCoordinate, 1);
		break;

	case 78:
		addStyleSym(Styles::PointSigma, 1);
		if (!_lexerMode)
			_curPoint->position.sigmax = sym(1).toDouble();
		gotPointSigma(sym(1));
		break;

	case 79:
		addStyleSym(Styles::PointSigma, 1);
		if (!_lexerMode)
			_curPoint->position.sigmay = sym(1).toDouble();
		gotPointSigma(sym(1));
		break;

	case 80:
		addStyleSym(Styles::PointSigma, 1);
		if (!_lexerMode)
			_curPoint->position.sigmaz = sym(1).toDouble();
		gotPointSigma(sym(1));
		break;
 case 81:  case 82: 
	case 83:
		addStyleSym(Styles::PointDisplacement, 1);
		gotPointDisplacement(sym(1));
		break;
 case 84: 
	case 85:
		addStyleSym(Styles::PointInfo, 1);
		if (!_lexerMode)
			_curPoint->extraInfos.addExtraInfo("id", toByteArray(toTrimmedQString(sym(1)), utf8()).constData());
		gotPointInfo(sym(1));
		break;

	case 86:
		addStyleSym(Styles::PointInfo, 1);
		if (!_lexerMode)
			_curPoint->extraInfos.addExtraInfo("DCUM", toByteArray(toTrimmedQString(sym(1)), utf8()).constData());
		gotPointInfo(sym(1));
		break;

	case 87:
	{
		QStringRef type = sym(1).trimmed();
		if (type == "CALA")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = false;
				_curPoint->position.isfreey = false;
				_curPoint->position.isfreez = false;
			}
		}
		else if (type == "POIN" || type == "VXYZ")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = true;
				_curPoint->position.isfreey = true;
				_curPoint->position.isfreez = true;
			}
		}
		else if (type == "VXY")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = true;
				_curPoint->position.isfreey = true;
				_curPoint->position.isfreez = false;
			}
		}
		else if (type == "VXZ")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = true;
				_curPoint->position.isfreey = false;
				_curPoint->position.isfreez = true;
			}
		}
		else if (type == "VYZ")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = false;
				_curPoint->position.isfreey = true;
				_curPoint->position.isfreez = true;
			}
		}
		else if (type == "VZ")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = false;
				_curPoint->position.isfreey = false;
				_curPoint->position.isfreez = true;
			}
		}
		gotPointType(sym(1));
		break;
	}
 case 96: 
	case 97:
		addStyleSym(Styles::Comment, 1);
		break;

	case 98:
		addStyleSym(Styles::Normal, 1);
		break;

	case 117:
		addStyleSym(Styles::Normal, 8);
		break;

	case 137:
		_contexts.push_back(CooLexerIO::OUT1MODE);
		break;

	} // of the switch
}

int CooLexerIO::nextToken(QStringRef value)
{
	static const QRegularExpression numericrgx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^-?[[:digit:]]*\.?[[:digit:]]+$)""");
		rgx.optimize();
		return rgx;
	})();

	QStringRef tval = value.trimmed();
	if (tval.isEmpty())
		return CooLexerIO::WORD;

	// comment
	if (commentChars().contains(tval[0]))
	{
		if (tval == CooLexerIO::spell[CooLexerIO::OLOC])
			return CooLexerIO::OLOC;
		if (tval == CooLexerIO::spell[CooLexerIO::LEP])
			return CooLexerIO::LEP;
		if (tval == CooLexerIO::spell[CooLexerIO::RS2K])
			return CooLexerIO::RS2K;
		if (tval == CooLexerIO::spell[CooLexerIO::SPHE])
			return CooLexerIO::SPHE;
		return CooLexerIO::COMMENTSTRING;
	}
	// numbers
	if (tval == "NA" || tval == "nan" || tval == "NAN")
		return CooLexerIO::DECIMAL;
	if (numericrgx.match(tval).hasMatch())
	{
		bool ok;
		tval.toInt(&ok);
		if (ok)
			return CooLexerIO::INTEGER;
		tval.toDouble(&ok);
		if (ok)
			return CooLexerIO::DECIMAL;
	}
	// keywords
	if (value.position() == _currentLine.position() && _currentLine.trimmed().startsWith(CooLexerIO::spell[CooLexerIO::HTOL]))
		return CooLexerIO::HTOL;
	if (_contexts.empty() && value.position() == _currentLine.position() && tval == CooLexerIO::spell[CooLexerIO::NOM])
	{
		_inlineContexts.insert(CooLexerIO::COLUMNDEF);
		return CooLexerIO::NOM;
	}
	if (value.position() == _currentLine.position() && tval == CooLexerIO::spell[CooLexerIO::FRAME_NAME])
	{
		_inlineContexts.insert(CooLexerIO::COLUMNDEF);
		return CooLexerIO::FRAME_NAME;
	}
	if (!_inlineContexts.empty())
	{
		for (int i = CooLexerIO::NOM; i < CooLexerIO::TERMINAL_COUNT; i++)
		{
			if (tval.startsWith(CooLexerIO::spell[i]))
				return i;
		}
	}

	// percentage
	if (tval[0] == '%')
		return CooLexerIO::PERCENTAGE; 

	return CooLexerIO::WORD;
}
